
import java.util.ArrayList;
import java.util.Random;

class Tantrix {

	private HexBoard Board;
   private Random RandGen;

	private Define define;   

	public Tantrix(int boardSizeX, int boardSizeY, String tilesToUse) {
		//Board = new HexBoard(boardSizeX, boardSizeY, ALL_TILES);
		Board = new HexBoard(boardSizeX, boardSizeY, tilesToUse);
		RandGen = new Random();
	}
	
	// A board initialisation function - places random tiles at
	// random orientations on the board.
	private void init_Random() {
		int x, y, t, o, p;
		
		// Fill a list with our available tiles		
		ArrayList L = new ArrayList(Board.Tiles.numTiles);
		
		// Generate a list of the tiles we have
		for (t=0; t<Board.Tiles.numTiles; t++) {
			Integer iObject = new Integer(t);
			L.add(t, iObject);
		}
		
		// Place random tiles at each position on the board
		for (x=0; x<Board.sizeX; x++) {
			for (y=0; y<Board.sizeY; y++) {
				
				// Pick random tile and orientation
				p=0;//p = RandGen.nextInt(L.size());
				o = RandGen.nextInt(6);
				
				// Place tile in position
				Integer iObject = (Integer) L.get(p);
				t = iObject.intValue();

				// Place the tile				
				Board.PlaceTile(t, o, x, y);
				
				// Record that it is no longer available in our list
				L.remove(p);
				
			}
		}
	}

	public int solve() {
		int x1, y1, x2, y2, t1;
		int o1, o2;
		int move=0;
		
	   // Place tiles randomly
	   init_Random();
	   // Update the violation matrix
	   Board.CountViolations();

	   
	   while (Board.violations.total>0 && move < define.TIME_OUT) {
   		// Pick a random tile in conflict
   		t1 = Board.conflict[RandGen.nextInt(Board.numInConflict)];

			// Get <x, y> for this tile
			x1 = t1 / Board.sizeY;
			y1 = t1 % Board.sizeY;

			// Pick a random second tile
			x2 = RandGen.nextInt(Board.sizeX);
			y2 = RandGen.nextInt(Board.sizeY);

			o1 = RandGen.nextInt(6);
			o2 = RandGen.nextInt(6);

			Board.SwapTiles(x1, y1, x2, y2, o1, o2);
			
			move++;
			System.out.println("Move: "+move+" Violations: "+Board.violations.total);
	   }
	   
		return 0;

	}

	public static void main(String args[]) {
	   Tantrix T = new Tantrix(2, 3, "YYYYYYYYYYYYYYNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN");
	   T.solve();
	}
	
}